# remirepo/fedora spec file for php-composer-xdebug-handler
#
# Copyright (c) 2018-2019 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global gh_commit    1ab9842d69e64fb3a01be6b656501032d1b78cb7
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
#global gh_date      20150717
%global gh_owner     composer
%global gh_project   xdebug-handler

%global ns_vendor    Composer
%global ns_project   XdebugHandler

%global php_home     %{_datadir}/php
%global with_tests   0%{!?_without_tests:1}

Name:           php-%{gh_owner}-%{gh_project}
Version:        1.4.1
Release:        1%{?gh_date:.%{gh_date}git%{gh_short}}%{?dist}
Summary:        Restarts a process without Xdebug

License:        MIT
URL:            https://github.com/%{gh_owner}/%{gh_project}
# git snapshot to get upstream test suite
Source0:        %{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
%if %{with_tests}
# For tests
BuildRequires:  php(language) >= 5.3.2
BuildRequires:  php-reflection
BuildRequires:  php-ctype
BuildRequires:  php-pcre
BuildRequires:  php-posix
BuildRequires:  php-spl
# From composer.json,     "require-dev": {
#        "phpunit/phpunit": "^4.8.35 || ^5.7 || 6.5 - 8"
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires: (php-composer(psr/log) >= 1.0   with php-composer(psr/log) < 2)
BuildRequires:  phpunit8
%global phpunit %{_bindir}/phpunit6
%else
BuildRequires:  php-PsrLog
BuildRequires:  php-phpunit-PHPUnit >= 4.8.35
%global phpunit %{_bindir}/phpunit
%endif
# Autoloader
BuildRequires:  php-composer(fedora/autoloader)
%endif

# From composer.json, "require": {
#        "php": "^5.3.2 || ^7.0 || ^8.0",
#        "psr/log": "^1.0"
Requires:       php(language) >= 5.3.2
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
Requires:      (php-composer(psr/log) >= 1.0   with php-composer(psr/log) < 2)
%else
Requires:       php-PsrLog
%endif
# From phpcompatinfo report for version 1.0.0
Requires:       php-reflection
Requires:       php-ctype
Requires:       php-pcre
Requires:       php-posix
Requires:       php-spl
# Autoloader
Requires:       php-composer(fedora/autoloader)

Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}


%description
Restart a CLI process without loading the xdebug extension.

Originally written as part of composer/composer, now extracted
and made available as a stand-alone library.

Autoloader: %{_datadir}/php/%{ns_vendor}/%{ns_project}/autoload.php


%prep
%setup -q -n %{gh_project}-%{gh_commit}


%build
cat << 'EOF' | tee src/autoload.php
<?php
/* Autoloader for %{name} and its dependencies */
require_once '%{_datadir}/php/Fedora/Autoloader/autoload.php';

\Fedora\Autoloader\Autoload::addPsr4('%{ns_vendor}\\%{ns_project}\\', __DIR__);
\Fedora\Autoloader\Dependencies::required(array(
    '%{_datadir}/php/Psr/Log/autoload.php',
));
EOF


%install
: Library
mkdir -p   %{buildroot}%{_datadir}/php/%{ns_vendor}
cp -pr src %{buildroot}%{_datadir}/php/%{ns_vendor}/%{ns_project}


%check
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{_datadir}/php/%{ns_vendor}/%{ns_project}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('%{ns_vendor}\\%{ns_project}\\', dirname(__DIR__).'/tests');
EOF

%if %{with_tests}
ret=0
for cmdarg in "php %{phpunit}" "php70 %{_bindir}/phpunit6" "php71 %{_bindir}/phpunit7" php72 php73 php74; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit8} --verbose|| ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc composer.json
%doc *.md
%dir %{_datadir}/php/%{ns_vendor}
     %{_datadir}/php/%{ns_vendor}/%{ns_project}


%changelog
* Mon Mar  2 2020 Remi Collet <remi@remirepo.net> - 1.4.1-1
- update to 1.4.1

* Thu Nov  7 2019 Remi Collet <remi@remirepo.net> - 1.4.0-1
- update to 1.4.0
- switch to phpunit8

* Tue May 28 2019 Remi Collet <remi@remirepo.net> - 1.3.3-1
- update to 1.3.3

* Tue Jan 29 2019 Remi Collet <remi@remirepo.net> - 1.3.2-1
- update to 1.3.2

* Thu Nov 29 2018 Remi Collet <remi@remirepo.net> - 1.3.1-1
- update to 1.3.1

* Sun Sep  2 2018 Remi Collet <remi@remirepo.net> - 1.3.0-1
- update to 1.3.0

* Thu Aug 23 2018 Remi Collet <remi@remirepo.net> - 1.2.1-1
- update to 1.2.1

* Fri Aug 17 2018 Remi Collet <remi@remirepo.net> - 1.2.0-1
- update to 1.2.0

* Mon Jun  4 2018 Remi Collet <remi@remirepo.net> - 1.1.0-2
- fix dependency on PHPUnit

* Thu Apr 12 2018 Remi Collet <remi@remirepo.net> - 1.1.0-1
- update to 1.1.0

* Mon Mar 26 2018 Remi Collet <remi@remirepo.net> - 1.0.0-1
- initial package, version 1.0.0
